/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
package com.altimetrik.playground.innovation.bean;

import java.io.Serializable;

import lombok.Data;

@Data
public class StatusDetails implements Serializable {

	private static final long serialVersionUID = -2104867973562059147L;

	/**
	 * Success Status code.
	 */
	public static final int SUCCESS = 1;

	/**
	 * Failure Status code.
	 */
	public static final int FAILED = 0;

	private Integer statusCode;
	private String errorCode;
	private String messageDescription;

	public StatusDetails() {
		super();
	}

	public StatusDetails(String errorCode, String messageDescription) {
		super();
		this.errorCode = errorCode;
		this.messageDescription = messageDescription;
	}

	public StatusDetails(Integer statusCode) {
		super();
		this.statusCode = statusCode;
	}

}
