/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
package com.altimetrik.playground.innovation.constants;

import java.util.HashSet;
import java.util.Set;

/**
 * Indicates different possible user types available.
 * 
 * @author skondapalli.
 */
public enum UserTypeEnum {

	TEAM_MEMBER("TEAM_MEMBER"), REVIEWER("REVIEWER");

	private final String message;

	UserTypeEnum(final String argMessage) {
		message = argMessage;
	}

	public final String getMessage() {
		return message;
	}

	public Set<IdeaStatusEnum> getAllowedIdeaStatusTransitions() {
		final Set<IdeaStatusEnum> allowedIdeaStatusTransitions = new HashSet<IdeaStatusEnum>();
		switch (this) {
		case REVIEWER:
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.REWORK);
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.PUBLISH);
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.REJECTED);
			break;
		case TEAM_MEMBER:
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.DRAFT);
			allowedIdeaStatusTransitions.add(IdeaStatusEnum.L0_REVIEW);
			break;
		}
		return allowedIdeaStatusTransitions;
	}

}
