/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
package com.altimetrik.playground.innovation.feature;

import org.togglz.core.Feature;
import org.togglz.core.annotation.EnabledByDefault;
import org.togglz.core.annotation.Label;
import org.togglz.core.context.FeatureContext;

import com.altimetrik.playground.innovation.exception.FeatureNotEnabledException;

public enum Features implements Feature {

	@Standard
	@EnabledByDefault
	@Label("Invite Request Acceptance")
	ACCEPT_INVITE,

	@Standard
	@Label("Join Request Approval")
	APPROVE_JOIN;

	// Reduced the scope for exception handling using a FeatureValidatorUtil
	// class.
	private boolean isActive() throws FeatureNotEnabledException {
		return FeatureContext.getFeatureManager().isActive(this);
	}

}
