/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
package com.altimetrik.playground.innovation.rabbitmq;

import java.util.Calendar;

import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.altimetrik.playground.innovation.config.RabbitConfig;
import com.fasterxml.jackson.databind.ObjectMapper;

import lombok.extern.slf4j.Slf4j;

@Slf4j
@Service
public class MessagePublisher {

	@Autowired
	private RabbitTemplate rabbitTemplate;

	public void publishMessageToQueue(final Object message) {
		try {
			this.rabbitTemplate.convertAndSend(RabbitConfig.EXCHANGE_NAME, RabbitConfig.ROUTING_KEY_NAME, new ObjectMapper().writeValueAsString(message));
			log.info("Published the message at " + Calendar.getInstance().getTime());
		}
		catch (Exception e) {
			// Log the exception.
		}
	}

}
