/**
 * Copyright (C) Altimetrik 2018. All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 */

package com.altimetrik.playground.innovation.security;

import java.util.Optional;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.AuditorAware;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;

/**
 * The Class AuditorAwareImpl.
 * @author Altimetrik CodeGen
 */
public class SpringSecurityAuditorAware implements AuditorAware<String> {

	@Value("${regulus.security.enabled:true}")
	private boolean securityEnabled;

	@Override
	public Optional<String> getCurrentAuditor() {
		final Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
		if (authentication == null && !securityEnabled) {
			return Optional.of("Sysadmin");
		}
		String userId = AuthValidatorUtil.getUserId(authentication);
		return Optional.of(userId);
	}

}
