/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
/*package com.altimetrik.playground.innovation.controller;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.mockito.MockitoAnnotations;
import org.mockito.Spy;
import org.skyscreamer.jsonassert.JSONAssert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.MediaType;
import org.springframework.mock.web.MockHttpServletResponse;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;
import org.springframework.test.web.servlet.setup.MockMvcBuilders;

import com.altimetrik.playground.innovation.bean.PgIdeaCategoryRequestBean;
import com.altimetrik.playground.innovation.bean.PgIdeaCategoryResponseBean;
import com.altimetrik.playground.innovation.bean.PgUserRequestBean;
import com.altimetrik.playground.innovation.bean.PgUserResponseBean;
import com.altimetrik.playground.innovation.bean.ResponseDetailsBean;
import com.altimetrik.playground.innovation.constants.RequestStatusEnum;
import com.altimetrik.playground.innovation.constants.RoleTypeEnum;
import com.altimetrik.playground.innovation.service.impl.PgIdeaCategoryServiceImpl;
import com.altimetrik.playground.innovation.util.ResponseBuilderUtil;
import com.google.gson.Gson;

@SpringBootTest
@RunWith(SpringRunner.class)
public class PgIdeaCategoryContollerTests {

	@Autowired
	private Gson gson;

	private MockMvc mockMvc;

	@Spy
	private ResponseBuilderUtil responseBuilderUtil;

	@Mock
	private PgIdeaCategoryServiceImpl pgIdeaCategoryService;

	@InjectMocks
	private PgIdeaCategoryContoller pgIdeaCategoryContoller;

	@Before
	public void setUp() {
		MockitoAnnotations.initMocks(this);
		this.mockMvc = MockMvcBuilders.standaloneSetup(this.pgIdeaCategoryContoller).build();
	}

	private PgIdeaCategoryRequestBean mockPgIdeaCategoryRequest() {
		return new PgIdeaCategoryRequestBean(Long.valueOf(1), "Category", this.mockPgIdeaReviewerRequest(RoleTypeEnum.REVIEWER), "admin@mail.com");
	}

	private List<PgUserRequestBean> mockPgIdeaReviewerRequest(RoleTypeEnum roleType) {
		final List<PgUserRequestBean> pgIdeaReviewers = new ArrayList<PgUserRequestBean>();
		pgIdeaReviewers.add(this.mockPgUserRequest(roleType));
		return pgIdeaReviewers;
	}

	private PgUserRequestBean mockPgUserRequest(RoleTypeEnum roleType) {
		PgUserRequestBean pgUserRequest = null;
		switch (roleType) {
		case REVIEWER:
			pgUserRequest = new PgUserRequestBean("admin@mail.com", "Reviewer", "reviewer@mail.com", Long.valueOf(1), roleType);
			break;
		}
		return pgUserRequest;
	}

	private PgIdeaCategoryResponseBean mockPgIdeaCategoryResponse() {
		final Set<PgUserResponseBean> pgIdeaReviewerResponses = new HashSet<PgUserResponseBean>();
		pgIdeaReviewerResponses.add(this.mockPgUserResponse(RoleTypeEnum.REVIEWER));
		return new PgIdeaCategoryResponseBean(1, "Category", pgIdeaReviewerResponses);
	}

	private PgUserResponseBean mockPgUserResponse(RoleTypeEnum roleType) {
		PgUserResponseBean pgUserResponse = null;
		switch (roleType) {
		case REVIEWER:
			pgUserResponse = new PgUserResponseBean("Reviewer", "reviewer@mail.com", Long.valueOf(1), roleType);
			break;
		}
		return pgUserResponse;
	}

	@Test
	public void saveCategoryTest() throws Exception {
		final String expectedResponse = this.gson.toJson(new ResponseDetailsBean(RequestStatusEnum.SUCCESS, true, null));
		Mockito.when(this.pgIdeaCategoryService.saveCategory(Mockito.any())).thenReturn(true);
		MockHttpServletResponse response = mockMvc.perform(MockMvcRequestBuilders.post("/v1/category").accept(MediaType.APPLICATION_JSON)
				.content(this.gson.toJson(this.mockPgIdeaCategoryRequest())).contentType(MediaType.APPLICATION_JSON)).andReturn().getResponse();
		JSONAssert.assertEquals(expectedResponse, response.getContentAsString(), true);
	}

	@Test
	public void getAllCategoriesTest() throws Exception {
		final List<PgIdeaCategoryResponseBean> pgIdeaCategoryResponses = new ArrayList<PgIdeaCategoryResponseBean>();
		pgIdeaCategoryResponses.add(this.mockPgIdeaCategoryResponse());
		final String expectedResponse = this.gson.toJson(new ResponseDetailsBean(RequestStatusEnum.SUCCESS, pgIdeaCategoryResponses, null));
		Mockito.when(this.pgIdeaCategoryService.findAllCategories()).thenReturn(pgIdeaCategoryResponses);
		MockHttpServletResponse response = mockMvc
				.perform(MockMvcRequestBuilders.get("/v1/category/list").accept(MediaType.APPLICATION_JSON).contentType(MediaType.APPLICATION_JSON)).andReturn().getResponse();
		JSONAssert.assertEquals(expectedResponse, response.getContentAsString(), true);
	}

}
*/
