/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
/*package com.altimetrik.playground.innovation.controller;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.mockito.MockitoAnnotations;
import org.mockito.Spy;
import org.skyscreamer.jsonassert.JSONAssert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.MediaType;
import org.springframework.mock.web.MockHttpServletResponse;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.request.MockMvcRequestBuilders;
import org.springframework.test.web.servlet.setup.MockMvcBuilders;

import com.altimetrik.playground.innovation.bean.PgIdeaCategoryResponseBean;
import com.altimetrik.playground.innovation.bean.PgIdeaCollateralRequestBean;
import com.altimetrik.playground.innovation.bean.PgIdeaCollateralResponseBean;
import com.altimetrik.playground.innovation.bean.PgIdeaRequestBean;
import com.altimetrik.playground.innovation.bean.PgIdeaResponseBean;
import com.altimetrik.playground.innovation.bean.PgIdeaStatusRequestBean;
import com.altimetrik.playground.innovation.bean.PgUserRequestBean;
import com.altimetrik.playground.innovation.bean.PgUserResponseBean;
import com.altimetrik.playground.innovation.bean.ResponseDetailsBean;
import com.altimetrik.playground.innovation.constants.ArtifactModeEnum;
import com.altimetrik.playground.innovation.constants.ArtifactTypeEnum;
import com.altimetrik.playground.innovation.constants.IdeaStatusEnum;
import com.altimetrik.playground.innovation.constants.RequestStatusEnum;
import com.altimetrik.playground.innovation.constants.RoleTypeEnum;
import com.altimetrik.playground.innovation.constants.UserTypeEnum;
import com.altimetrik.playground.innovation.service.impl.PgIdeaServiceImpl;
import com.altimetrik.playground.innovation.util.ResponseBuilderUtil;
import com.google.gson.Gson;

@SpringBootTest
@RunWith(SpringRunner.class)
public class PgIdeaContollerTests {

	@Autowired
	private Gson gson;

	private MockMvc mockMvc;

	@Spy
	private ResponseBuilderUtil responseBuilderUtil;

	@Mock
	private PgIdeaServiceImpl pgIdeaService;

	@InjectMocks
	private PgIdeaContoller pgIdeaContoller;

	@Before
	public void setUp() {
		MockitoAnnotations.initMocks(this);
		this.mockMvc = MockMvcBuilders.standaloneSetup(this.pgIdeaContoller).build();
	}

	private PgIdeaRequestBean mockPgIdeaRequest() {
		return new PgIdeaRequestBean("Idea", true, "Idea", true, "Idea", Long.valueOf(1), IdeaStatusEnum.DRAFTED, this.mockPgIdeaTeamMemberRequest(RoleTypeEnum.INNOVATOR),
				this.mockPgIdeaCollateralRequest(), "admin@mail.com");
	}

	private Set<PgUserRequestBean> mockPgIdeaTeamMemberRequest(RoleTypeEnum roleType) {
		final Set<PgUserRequestBean> pgIdeaTeamMembers = new HashSet<PgUserRequestBean>();
		pgIdeaTeamMembers.add(this.mockPgUserRequest(roleType));
		return pgIdeaTeamMembers;
	}

	private Set<PgIdeaCollateralRequestBean> mockPgIdeaCollateralRequest() {
		final Set<PgIdeaCollateralRequestBean> pgIdeaCollaterals = new HashSet<PgIdeaCollateralRequestBean>();
		pgIdeaCollaterals.add(new PgIdeaCollateralRequestBean("link", ArtifactTypeEnum.LINK, ArtifactModeEnum.IDEA));
		return pgIdeaCollaterals;
	}

	private PgUserRequestBean mockPgUserRequest(RoleTypeEnum roleType) {
		PgUserRequestBean pgUserRequest = null;
		switch (roleType) {
		case INNOVATOR:
			pgUserRequest = new PgUserRequestBean("innovator@mail.com", "Innovator", "innovator@mail.com", Long.valueOf(1), roleType);
			break;
		}
		return pgUserRequest;
	}

	private List<PgIdeaResponseBean> mockPgIdeaResponse() {
		List<PgIdeaResponseBean> pgIdeaResponses = new ArrayList<PgIdeaResponseBean>();
		pgIdeaResponses.add(new PgIdeaResponseBean(Long.valueOf(1), "Idea", true, "Idea", true, "Idea", IdeaStatusEnum.DRAFTED, this.mockPgIdeaCategoryResponse(),
				this.mockPgIdeaTeamMemberResponse(RoleTypeEnum.INNOVATOR), this.mockPgIdeaCollateralResponse()));
		return pgIdeaResponses;
	}

	private PgIdeaCategoryResponseBean mockPgIdeaCategoryResponse() {
		final Set<PgUserResponseBean> pgIdeaReviewerResponses = new HashSet<PgUserResponseBean>();
		pgIdeaReviewerResponses.add(this.mockPgUserResponse(RoleTypeEnum.REVIEWER));
		return new PgIdeaCategoryResponseBean(1, "Category", pgIdeaReviewerResponses);
	}

	private Set<PgUserResponseBean> mockPgIdeaTeamMemberResponse(RoleTypeEnum roleType) {
		final Set<PgUserResponseBean> pgIdeaTeamMemberResponses = new HashSet<PgUserResponseBean>();
		pgIdeaTeamMemberResponses.add(this.mockPgUserResponse(roleType));
		return pgIdeaTeamMemberResponses;
	}

	private Set<PgIdeaCollateralResponseBean> mockPgIdeaCollateralResponse() {
		final Set<PgIdeaCollateralResponseBean> pgIdeaCollateralResponses = new HashSet<PgIdeaCollateralResponseBean>();
		pgIdeaCollateralResponses.add(new PgIdeaCollateralResponseBean(Long.valueOf(1), "link", ArtifactTypeEnum.LINK, ArtifactModeEnum.IDEA));
		return pgIdeaCollateralResponses;
	}

	private PgUserResponseBean mockPgUserResponse(RoleTypeEnum roleType) {
		PgUserResponseBean pgUserResponse = null;
		switch (roleType) {
		case REVIEWER:
			pgUserResponse = new PgUserResponseBean("Reviewer", "reviewer@mail.com", Long.valueOf(1), roleType);
			break;
		case INNOVATOR:
			pgUserResponse = new PgUserResponseBean("Innovator", "innovator@mail.com", Long.valueOf(1), roleType);
			break;
		}
		return pgUserResponse;
	}

	@Test
	public void saveIdeaTest() throws Exception {
		final String expectedResponse = this.gson.toJson(new ResponseDetailsBean(RequestStatusEnum.SUCCESS, true, null));
		Mockito.when(this.pgIdeaService.saveIdea(Mockito.any())).thenReturn(true);
		MockHttpServletResponse response = mockMvc.perform(MockMvcRequestBuilders.post("/v1/role/idea").accept(MediaType.APPLICATION_JSON)
				.content(new Gson().toJson(this.mockPgIdeaRequest())).contentType(MediaType.APPLICATION_JSON)).andReturn().getResponse();
		JSONAssert.assertEquals(expectedResponse, response.getContentAsString(), true);
	}

	@Test
	public void getAllIdeasTest() throws Exception {
		final String expectedResponse = this.gson.toJson(new ResponseDetailsBean(RequestStatusEnum.SUCCESS, this.mockPgIdeaResponse(), null));
		Mockito.when(this.pgIdeaService.findAllIdeas(Mockito.any())).thenReturn(this.mockPgIdeaResponse());
		MockHttpServletResponse response = mockMvc
				.perform(MockMvcRequestBuilders.get("/v1/idea/list/DRAFTED").accept(MediaType.APPLICATION_JSON).contentType(MediaType.APPLICATION_JSON)).andReturn().getResponse();
		JSONAssert.assertEquals(expectedResponse, response.getContentAsString(), true);
	}

	@Test
	public void getAllUserIdeasTest() throws Exception {
		final String expectedResponse = this.gson.toJson(new ResponseDetailsBean(RequestStatusEnum.SUCCESS, this.mockPgIdeaResponse(), null));
		Mockito.when(this.pgIdeaService.findAllIdeas(UserTypeEnum.TEAM_MEMBER, Long.valueOf(1), IdeaStatusEnum.ALL)).thenReturn(this.mockPgIdeaResponse());
		MockHttpServletResponse response = mockMvc
				.perform(MockMvcRequestBuilders.get("/v1/idea/list/TEAM_MEMBER/1/ALL").accept(MediaType.APPLICATION_JSON).contentType(MediaType.APPLICATION_JSON)).andReturn()
				.getResponse();
		JSONAssert.assertEquals(expectedResponse, response.getContentAsString(), true);
	}

	@Test
	public void updateIdeaStatusTest() throws Exception {
		final PgIdeaStatusRequestBean pgIdeaStatusRequest = new PgIdeaStatusRequestBean(Long.valueOf(1), IdeaStatusEnum.SUBMITTED);
		final String expectedResponse = this.gson.toJson(new ResponseDetailsBean(RequestStatusEnum.SUCCESS, true, null));
		Mockito.when(this.pgIdeaService.updateIdeaStatus(Mockito.any())).thenReturn(true);
		MockHttpServletResponse response = mockMvc.perform(MockMvcRequestBuilders.post("/v1/role/idea/status").accept(MediaType.APPLICATION_JSON)
				.content(new Gson().toJson(pgIdeaStatusRequest)).contentType(MediaType.APPLICATION_JSON)).andReturn().getResponse();
		JSONAssert.assertEquals(expectedResponse, response.getContentAsString(), true);
	}

}
*/
