/*******************************************************************************
 * Copyright (C) Altimetrik 2018. All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Altimetrik. You shall not disclose such Confidential Information
 * and shall use it only in accordance with the terms and conditions
 * entered into with Altimetrik.
 ******************************************************************************/
/*package com.altimetrik.playground.innovation.service.impl;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.mockito.MockitoAnnotations;
import org.skyscreamer.jsonassert.JSONAssert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import com.altimetrik.playground.innovation.bean.PgIdeaCategoryRequestBean;
import com.altimetrik.playground.innovation.bean.PgIdeaCategoryResponseBean;
import com.altimetrik.playground.innovation.bean.PgUserRequestBean;
import com.altimetrik.playground.innovation.bean.PgUserResponseBean;
import com.altimetrik.playground.innovation.constants.RoleTypeEnum;
import com.altimetrik.playground.innovation.entity.PgIdeaCategoryEntity;
import com.altimetrik.playground.innovation.entity.PgIdeaReviewerEntity;
import com.altimetrik.playground.innovation.entity.PgIdeaReviewerId;
import com.altimetrik.playground.innovation.entity.PgUserEntity;
import com.altimetrik.playground.innovation.repository.PgIdeaCategoryRepository;
import com.google.gson.Gson;

@SpringBootTest
@RunWith(SpringRunner.class)
public class PgIdeaCategoryServiceImplTests {

	@Autowired
	private Gson gson;

	@InjectMocks
	private PgIdeaCategoryServiceImpl pgIdeaCategoryService;

	@Mock
	private PgIdeaCategoryRepository pgIdeaCategoryRepository;

	@Before
	public void setUp() {
		MockitoAnnotations.initMocks(this);
	}

	private PgIdeaCategoryRequestBean mockPgIdeaCategoryRequest() {
		return new PgIdeaCategoryRequestBean(Long.valueOf(1), "Category", this.mockPgIdeaReviewerRequest(RoleTypeEnum.REVIEWER), "admin@mail.com");
	}

	private List<PgUserRequestBean> mockPgIdeaReviewerRequest(RoleTypeEnum roleType) {
		final List<PgUserRequestBean> pgIdeaReviewers = new ArrayList<PgUserRequestBean>();
		pgIdeaReviewers.add(this.mockPgUserRequest(roleType));
		return pgIdeaReviewers;
	}

	private PgUserRequestBean mockPgUserRequest(RoleTypeEnum roleType) {
		PgUserRequestBean pgUserRequest = null;
		switch (roleType) {
		case REVIEWER:
			pgUserRequest = new PgUserRequestBean("admin@mail.com", "Reviewer", "reviewer@mail.com", Long.valueOf(1), roleType);
			break;
		}
		return pgUserRequest;
	}

	private PgIdeaCategoryEntity mockPgIdeaCategory() {
		final Set<PgIdeaReviewerEntity> pgIdeaReviewers = new HashSet<PgIdeaReviewerEntity>();
		pgIdeaReviewers.add(this.mockPgIdeaReviewer());
		return new PgIdeaCategoryEntity("admin@mail.com", Long.valueOf(1), "Category", pgIdeaReviewers);
	}

	private PgIdeaReviewerEntity mockPgIdeaReviewer() {
		return new PgIdeaReviewerEntity("admin@mail.com", new PgIdeaReviewerId(Long.valueOf(1), Long.valueOf(1)), this.mockPgUser(RoleTypeEnum.REVIEWER));
	}

	private PgUserEntity mockPgUser(RoleTypeEnum roleType) {
		PgUserEntity pgUser = null;
		switch (roleType) {
		case REVIEWER:
			pgUser = new PgUserEntity("admin@mail.com", Long.valueOf(1), "Reviewer", "reviewer@mail.com");
			break;
		}
		return pgUser;
	}

	private PgIdeaCategoryResponseBean mockPgIdeaCategoryResponse() {
		final Set<PgUserResponseBean> pgIdeaReviewerResponses = new HashSet<PgUserResponseBean>();
		pgIdeaReviewerResponses.add(this.mockPgUserResponse(RoleTypeEnum.REVIEWER));
		return new PgIdeaCategoryResponseBean(1, "Category", pgIdeaReviewerResponses);
	}

	private PgUserResponseBean mockPgUserResponse(RoleTypeEnum roleType) {
		PgUserResponseBean pgUserResponse = null;
		switch (roleType) {
		case REVIEWER:
			pgUserResponse = new PgUserResponseBean("Reviewer", "reviewer@mail.com", Long.valueOf(1), roleType);
			break;
		}
		return pgUserResponse;
	}

	@Test
	public void createCategoryTest() throws Exception {
		Mockito.when(this.pgIdeaCategoryRepository.findByIdeaCategoryName(Mockito.any())).thenReturn(null);
		Mockito.when(this.pgIdeaCategoryRepository.save(Mockito.any())).thenReturn(this.mockPgIdeaCategory());
		JSONAssert.assertEquals(String.valueOf(true), String.valueOf(this.pgIdeaCategoryService.saveCategory(this.mockPgIdeaCategoryRequest())), true);
	}

	@Test
	public void updateCategoryTest() throws Exception {
		Mockito.when(this.pgIdeaCategoryRepository.findByIdeaCategoryName(Mockito.any())).thenReturn(this.mockPgIdeaCategory());
		Mockito.when(this.pgIdeaCategoryRepository.save(Mockito.any())).thenReturn(this.mockPgIdeaCategory());
		JSONAssert.assertEquals(String.valueOf(true), String.valueOf(this.pgIdeaCategoryService.saveCategory(this.mockPgIdeaCategoryRequest())), true);
	}

	@Test
	public void findAllCategoriesTest() throws Exception {
		final List<PgIdeaCategoryEntity> pgIdeaCategories = new ArrayList<PgIdeaCategoryEntity>();
		pgIdeaCategories.add(this.mockPgIdeaCategory());
		List<PgIdeaCategoryResponseBean> pgIdeaCategoryResponses = new ArrayList<PgIdeaCategoryResponseBean>();
		pgIdeaCategoryResponses.add(this.mockPgIdeaCategoryResponse());
		Mockito.when(this.pgIdeaCategoryRepository.findAll()).thenReturn(pgIdeaCategories);
		JSONAssert.assertEquals(this.gson.toJson(pgIdeaCategoryResponses), this.gson.toJson(this.pgIdeaCategoryService.findAllCategories()), true);
	}

	@Test
	public void findAllCategoriesNullCheckTest() throws Exception {
		Mockito.when(this.pgIdeaCategoryRepository.findAll()).thenReturn(null);
		JSONAssert.assertEquals(this.gson.toJson(new ArrayList<PgIdeaCategoryResponseBean>()), this.gson.toJson(this.pgIdeaCategoryService.findAllCategories()), true);
	}

}
*/
